Loading...
Searching...
No Matches
juce::FileOutputStream Class Reference

## Detailed Description

An output stream that writes into a local file.

See also
  OutputStream, FileInputStream, File::createOutputStream

The documentation for this class was generated from the following file:

- juce_core/files/juce_FileOutputStream.h

Inheritance diagram for juce::FileOutputStream:

## Public Member Functions

| FileOutputStream (const File &fileToWriteTo, size_t bufferSizeToUse=16384)
| Creates a FileOutputStream.
| ~FileOutputStream () override
| Destructor.
const File & | getFile () const
| Returns the file that this stream is writing to.
const Result & | getStatus () const noexcept
| Returns the status of the file stream.
bool | failedToOpen () const noexcept
| Returns true if the stream couldn't be opened for some reason.
bool | openedOk () const noexcept
| Returns true if the stream opened without problems.
Result | truncate ()
| Attempts to truncate the file to the current write position.
void | flush () override
| If the stream is using a buffer, this will ensure it gets written out to the destination.
int64 | getPosition () override
| Returns the stream's current position.
bool | setPosition (int64) override
| Tries to move the stream's output position.
bool | write (const void *, size_t) override
| Writes a block of data to the stream.
bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat) override
| Writes a byte to the output stream a given number of times.
Public Member Functions inherited from juce::OutputStream
virtual | ~OutputStream ()
| Destructor.
virtual bool | writeByte (char byte)
| Writes a single byte to the stream.
virtual bool | writeBool (bool boolValue)
| Writes a boolean to the stream as a single byte.
virtual bool | writeShort (short value)
| Writes a 16-bit integer to the stream in a little-endian byte order.
virtual bool | writeShortBigEndian (short value)
| Writes a 16-bit integer to the stream in a big-endian byte order.
virtual bool | writeInt (int value)
| Writes a 32-bit integer to the stream in a little-endian byte order.
virtual bool | writeIntBigEndian (int value)
| Writes a 32-bit integer to the stream in a big-endian byte order.
virtual bool | writeInt64 (int64 value)
| Writes a 64-bit integer to the stream in a little-endian byte order.
virtual bool | writeInt64BigEndian (int64 value)
| Writes a 64-bit integer to the stream in a big-endian byte order.
virtual bool | writeFloat (float value)
| Writes a 32-bit floating point value to the stream in a binary format.
virtual bool | writeFloatBigEndian (float value)
| Writes a 32-bit floating point value to the stream in a binary format.
virtual bool | writeDouble (double value)
| Writes a 64-bit floating point value to the stream in a binary format.
virtual bool | writeDoubleBigEndian (double value)
| Writes a 64-bit floating point value to the stream in a binary format.
virtual bool | writeCompressedInt (int value)
| Writes a condensed binary encoding of a 32-bit integer.
virtual bool | writeString (const String &text)
| Stores a string in the stream in a binary format.
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
| Writes a string of text to the stream.
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
| Reads data from an input stream and writes it to this stream.
void | setNewLineString (const String &newLineString)
| Sets the string to write to the stream when a new line is written.
const String & | getNewLineString () const noexcept
| Returns the current new-line string that was set by setNewLineString().

## Additional Inherited Members

Protected Member Functions inherited from juce::OutputStream
| OutputStream ()

## Constructors and Destructors

## FileOutputStream()

juce::FileOutputStream::FileOutputStream | ( | const File & | fileToWriteTo,
|  | size_t | bufferSizeToUse = 16384 )

Creates a FileOutputStream.

If the file doesn't exist, it will first be created. If the file can't be created or opened (for example, because the parent directory of the file does not exist), the failedToOpen() method will return true.

If the file already exists when opened, the stream's write-position will be set to the end of the file. To overwrite an existing file, you can truncate it like this:

FileOutputStream stream (file);
if (stream.openedOk())
{
stream.setPosition (0);
stream.truncate();
...
}
juce::FileOutputStream::FileOutputStream
FileOutputStream(const File &fileToWriteTo, size_t bufferSizeToUse=16384)
Creates a FileOutputStream.

Destroying a FileOutputStream object does not force the operating system to write the buffered data to disk immediately. If this is required you should call flush() before triggering the destructor.

See also
  TemporaryFile

## ~FileOutputStream()

juce::FileOutputStream::~FileOutputStream | ( |  | ) |

override

Destructor.

## Member Functions

## getFile()

const File & juce::FileOutputStream::getFile | ( |  | ) | const

inline

Returns the file that this stream is writing to.

## getStatus()

const Result & juce::FileOutputStream::getStatus | ( |  | ) | const

inline noexcept

Returns the status of the file stream.

The result will be ok if the file opened successfully. If an error occurs while opening or writing to the file, this will contain an error message.

## failedToOpen()

bool juce::FileOutputStream::failedToOpen | ( |  | ) | const

inline noexcept

Returns true if the stream couldn't be opened for some reason.

See also
  getStatus()

## openedOk()

bool juce::FileOutputStream::openedOk | ( |  | ) | const

inline noexcept

Returns true if the stream opened without problems.

See also
  getStatus()

## truncate()

Result juce::FileOutputStream::truncate | ( |  | ) |

Attempts to truncate the file to the current write position.

To truncate a file to a specific size, first use setPosition() to seek to the appropriate location, and then call this method.

## flush()

void juce::FileOutputStream::flush | ( |  | ) |

override virtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implements juce::OutputStream.

## getPosition()

int64 juce::FileOutputStream::getPosition | ( |  | ) |

override virtual

Returns the stream's current position.

See also
  setPosition

Implements juce::OutputStream.

## setPosition()

bool juce::FileOutputStream::setPosition | ( | int64 | newPosition | ) |

override virtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements juce::OutputStream.

## write()

bool juce::FileOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes )

override virtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements juce::OutputStream.

## writeRepeatedByte()

bool juce::FileOutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat )

override virtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented from juce::OutputStream.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited